# wxClipboard Class Reference
[Clipboard and Drag & Drop]

`#include <wx/clipbrd.h>`

Inheritance diagram for wxClipboard:
[legend]

## Detailed Description

A class for manipulating the clipboard.

To use the clipboard, you call member functions of the global wxTheClipboard object.

See the wxDataObject Overview for further information.

Call wxClipboard::Open() to get ownership of the clipboard. If this operation returns true, you now own the clipboard. Call wxClipboard::SetData() to put data on the clipboard, or wxClipboard::GetData() to retrieve data from the clipboard. Call wxClipboard::Close() to close the clipboard and relinquish ownership. You should keep the clipboard open only momentarily.

For example:

        // Write some text to the clipboard
        if (wxTheClipboard->Open())
        {
            // This data objects are held by the clipboard,
            // so do not delete them in the app.
            wxTheClipboard->SetData( new wxTextDataObject("Some text") );
            wxTheClipboard->Close();
        }

        // Read some text
        if (wxTheClipboard->Open())
        {
            if (wxTheClipboard->IsSupported( wxDF_TEXT ))
            {
                wxTextDataObject data;
                wxTheClipboard->GetData( data );
                wxMessageBox( data.GetText() );
            }
            wxTheClipboard->Close();
        }

##

Library: wxCore

Category: Clipboard and Drag & Drop

See also:
  Drag and Drop Overview, wxDataObject Overview, wxDataObject

## Public Member Functions
| wxClipboard ()
| Default constructor.
virtual | ~wxClipboard ()
| Destructor.
virtual bool | AddData (wxDataObject *data)
| Call this function to add the data object to the clipboard.
virtual void | Clear ()
| Clears the global clipboard object and the system's clipboard if possible.
virtual void | Close ()
| Call this function to close the clipboard, having opened it with Open().
virtual bool | Flush ()
| Flushes the clipboard: this means that the data which is currently on clipboard will stay available even after the application exits (possibly eating memory), otherwise the clipboard will be emptied on exit.
virtual bool | GetData (wxDataObject &data)
| Call this function to fill data with data on the clipboard, if available in the required format.
virtual bool | IsOpened () const
| Returns true if the clipboard has been opened.
virtual bool | IsSupported (const wxDataFormat &format)
| Returns true if there is data which matches the data format of the given data object currently available on the clipboard.
bool | IsUsingPrimarySelection () const
| Returns true if we are using the primary selection, false if clipboard one.
virtual bool | Open ()
| Call this function to open the clipboard before calling SetData() and GetData().
virtual bool | SetData (wxDataObject *data)
| Call this function to set the data object to the clipboard.
virtual void | UsePrimarySelection (bool primary=false)
| On platforms supporting it (all X11-based ports), wxClipboard uses the CLIPBOARD X11 selection by default.

List of all members.

## Constructor & Destructor Documentation

wxClipboard::wxClipboard | ( |  | ) |

Default constructor.

virtual wxClipboard::~wxClipboard | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual bool wxClipboard::AddData | ( | wxDataObject * | data | ) | `[virtual]`

Call this function to add the data object to the clipboard.

You may call this function repeatedly after having cleared the clipboard using Clear().

After this function has been called, the clipboard owns the data, so do not delete the data explicitly.

See also:
  SetData()

virtual void wxClipboard::Clear | ( |  | ) | `[virtual]`

Clears the global clipboard object and the system's clipboard if possible.

virtual void wxClipboard::Close | ( |  | ) | `[virtual]`

Call this function to close the clipboard, having opened it with Open().

virtual bool wxClipboard::Flush | ( |  | ) | `[virtual]`

Flushes the clipboard: this means that the data which is currently on clipboard will stay available even after the application exits (possibly eating memory), otherwise the clipboard will be emptied on exit.

Returns:
  false if the operation is unsuccessful for any reason.

virtual bool wxClipboard::GetData | ( | wxDataObject & | data | ) | `[virtual]`

Call this function to fill data with data on the clipboard, if available in the required format.

Returns true on success.

virtual bool wxClipboard::IsOpened | ( |  | ) | const`[virtual]`

Returns true if the clipboard has been opened.

virtual bool wxClipboard::IsSupported | ( | const wxDataFormat & | format | ) | `[virtual]`

Returns true if there is data which matches the data format of the given data object currently available on the clipboard.

Todo:
  The name of this function is misleading. This should be renamed to something that more accurately indicates what it does.

bool wxClipboard::IsUsingPrimarySelection | ( |  | ) | const

Returns true if we are using the primary selection, false if clipboard one.

See also:
  UsePrimarySelection()

virtual bool wxClipboard::Open | ( |  | ) | `[virtual]`

Call this function to open the clipboard before calling SetData() and GetData().

Call Close() when you have finished with the clipboard. You should keep the clipboard open for only a very short time.

Returns:
  true on success. This should be tested (as in the sample shown above).

virtual bool wxClipboard::SetData | ( | wxDataObject * | data | ) | `[virtual]`

Call this function to set the data object to the clipboard.

This function will clear all previous contents in the clipboard, so calling it several times does not make any sense.

After this function has been called, the clipboard owns the data, so do not delete the data explicitly.

See also:
  AddData()

virtual void wxClipboard::UsePrimarySelection | ( | bool | primary = `false` | ) | `[virtual]`

On platforms supporting it (all X11-based ports), wxClipboard uses the CLIPBOARD X11 selection by default.

When this function is called with true, all subsequent clipboard operations will use PRIMARY selection until this function is called again with false.

On the other platforms, there is no PRIMARY selection and so all clipboard operations will fail. This allows to implement the standard X11 handling of the clipboard which consists in copying data to the CLIPBOARD selection only when the user explicitly requests it (i.e. by selecting the "Copy" menu command) but putting the currently selected text into the PRIMARY selection automatically, without overwriting the normal clipboard contents with the currently selected text on the other platforms.

|  | [ top ]